Introduction

Altap Salamander: Plugins: ZIP: Introduction

Getting Started with ZIP Plugin

ZIP plugin adds a support for ZIP archives. You can pack files and directories to ZIP archives; browse, test and unpack ZIP archives; delete files and directories from ZIP archives; create self-extracting ZIP archives (in several language versions); create multi-volume (spanned) ZIP archives (also self-extracting; and even on fixed disks); and view/edit ZIP archive comment. Files in ZIP archives (also self-extracting) can be encrypted.

See Archiver and Menu Extension sections in Using Plugins for a description of basic work with plugin archiver and menu extension.

© 2001-2019 ALTAP. All rights reserved.


Testing Archive

You can test ZIP archives for errors in file structure or compressed data.

To test ZIP archive:

  1. Select the ZIP archive files you want to test.
  2. Choose Test Archive command from menu Plugins/ZIP.


Archive Comment

ZIP archive can contain two types of comments. Comments to individual compressed files and comment to whole archive. ZIP plugin enables you to view, add and edit only archive comment.

To view/edit archive comment:

  1. Select the ZIP archive files for which you want to view/edit comment.
  2. Choose Archive Comment command from menu Plugins/ZIP.


Create New Archive Dialog

This dialog is displayed just before the packing to ZIP archive starts (Pack or Copy command). This dialog is labeled as Add Files to Archive when adding files to an existing archive (i.e. using the Copy command). You can specify here the packing options. Packing starts immediately with the default settings when showing of this dialog is disabled in the ZIP plugin configuration.

Dialog Box Options

Create multi-volume archive
Allows you to create multi-volume (spanned) archive. Archive file is splitted into several files (volumes) with specified maximal size. Typical usage: storing files to removable media (floppy disk, CD-ROM, etc.). ZIP plugin enables you also to create multi-volume archive stored on the fixed disk (with sequential filenames, see below).
Volume size
Maximal size of archive volume. If you select automatic ZIP plugin will detect free space on each inserted medium on target path and set volume maximal size according to this space.
Name files sequentially
Allows you to add a volume number to each archive volume. If you are packing to the fixed drive, this option is necessary because it is impossible to store multiple files with the same name to the same directory.
Note: not all zip archivers support multiple volume ZIP archives stored on the fixed disks or archives with sequential naming.
Create self-extracting archive
Enables you to create archive which can unpack itself. For more details see Self-Extracting Archives.
Advanced
Displays Self-Extractor Settings dialog.
Encrypt files
Enables file encryption. This option does not affect files which are already in the archive.
Encryption Method
The ZIP plugin supports 2 different encryption schemes. The legacy ZIP 2.0 method is nowadays considered weak (experts say they need less than two hours on a Pentium 500Mhz with 128MB and it is not dependent on the password length). The second scheme supported is the modern Advanced Encryption Standard (AES), with 2 lengths of keys - 128 bits and 256 bits. The longer key delivers better security on the expense of slightly longer encryption and decryption times. The key is generated from the user-provided password using the algorithm described in the RFC2898 document.
Warning: While virtually any software capable of dealing with ZIP archives can extract files encrypted with the legacy method, not every software can deal with AES-encrypted archives.
Warning: to achieve good security, it is highly recommended to use long passwords (more than 30 characters) mixing digits, lower-case and upper-case characters and other non-alphabetical symbols, such as colon.
You may also use the Encrypt plugin if you need higher level of security for your files.
Don't show this dialog again
Suppress displaying of this dialog before each packing to ZIP archive. You can enable displaying again in the ZIP Configuration.
Configure
Opens the ZIP Configuration dialog.

See Also

ZIP Configuration
Self-Extracting Archives


ZIP Configuration

Here you can set general options for the ZIP plugin. Configuration is accessible either from Altap Salamander Plugins Manager dialog (menu Plugins/Plugins Manager) or from the Create New Archive dialog. See Configuring Plugins for general information on configuration.

Options

Automatically expand multi-volume archives stored on fixed disk
Automatically find the last archive volume file (it contains information about files in the archive) and don't prompt user for locating of last archive. When last archive is found it lists or unpacks it without prompting for other archive volumes. This option applies only for multi-volume archives stored in fixed disks not for archives on removable media (e.g. floppy disk, CD-ROM).
Use temporary copy of archive for its modifications
For any action which changes ZIP archive (like packing or deleting files) ZIP plugin creates at first a backup copy of the archive and proceed the desired action on the backup copy. When the action is successfully finished original archive is replaced by the updated archive. In case of error the original is left unchanged. On the other hand there is a little slowdown through the backuping operation. It's strongly recommended to let ZIP keep backup copies while modifying archives.
Don't store empty directories in ZIP archive
Ignores empty directories when packing. This option doesn't affect empty directories already stored in the archive.
Set archive time to the newest file time when modifying archive
After any action which modifies an archive (files packing or deleting) ZIP plugin sets the archive file time to the time of the newest file in the archive. This option can be useful e.g. for backuping purposes.
Use WinZip compatible file names for multi-volume archives
Names of multi-volume archive parts are created using WinZip name conventions except for self-extracting archives. These are created using Altap Salamander naming conventions.
Compression level
Specify how much the files should be compressed. Level value 0 means store - no compression. Level 9 is the best possible (and slowest) compression which could be achieved with current ZIP compression algorithm (deflate).
Default self-extractor language
The default language of self-extracting archive. If you have invoked the ZIP Configuration dialog from the Create New Archive dialog, the change of the default language will not affect the current pack operation (use Advanced button from the Create New Archive dialog to change the language for the current pack operation).
When SFX language changes
You can specify your own texts for main window of self-extracting archive and optional message box which is displayed before main window (see Self-Extractor Texts dialog). Choose here what action should be taken when you are using such own texts and when you change language for self-extracting archive. Options are: Always ask before changing texts, Automatically replace texts with their default values, or Don't ask and leave always texts unchanged.
Display dialog with extended options before packing
Displays the Create New Archive/Add File to Archive dialog before each pack operation to ZIP archives. This lets you specify many options for packing ZIP archives which ZIP plugin offers you (like archive spanning, self-extracting archives or encryption).
Show column Packed when listing archive
Controls whether an extra column Packed with compressed size of the respective file should be added to the panel listing the archive in Detailed mode or Types mode.

See Also

Create New Archive and Add Files to Archive Dialogs


Introduction

Self-extracting archive is an executable file (.exe) which consists of ZIP archive file and Altap Self-Extractor (software to unpack/extract the archive). In ZIP plugin you can create self-extracting archives with many useful options.

The main advantage is that anyone can extract files from a self-extracting archive without need of any other software (ZIP unpacker) or knowing how to use a separate unzip utility. Thus self-extracting archives are particularly suited for distribution of software to beginning users who are not familiar with the concept of ZIP archives. Or you can use it when transporting ZIP archive to computer where needed ZIP software is probably not installed.

Using Altap Self-Extractor you can compress your installation software. After the installer is extracted, Altap Self-Extractor starts the installation or executes any other command you have specified. When the installation finishes, Altap Self-Extractor removes all temporary files.


Altap Self-Extractor

Altap Self-Extractor is a part of each ZIP self-extracting archive. It's started when user opens self-extracting archive. It unpacks archive to the target directory of user's choice (or optionally to designated directory without any user prompt).

Features:

  • ZIP format compatibility, including older ZIP formats.
  • Extracting also encrypted files.
  • Spanned self-extracting archives are supported.
  • Available in several language versions.
  • Custom title and text in the main self-extractor dialog.
  • Option to display a message box with user defined text when self-extractor starts.
  • Custom icon in self-extractor dialog and the executable file.
  • Custom text of the "extract" button.
  • Altap Self-Extractor can start program (e.g. your installer), open document or http link when an extraction is finished.
  • Ability to run standard .inf files as an alternative to setup programs.
  • Remove files extracted in a temporary folder when the started program is finished.
  • Remove files in a temporary folder even if the install program involves a reboot.
  • Ability to wait for finishing of specified program before temporary files are removed.
  • Option to specify target directory as the current directory, the temporary directory, the Program Files directory, the Windows directory, the System directory, or the directory specified by the environment variable or the Registry value.
  • Option to specify a subdirectory to create in the target directory when extracting self-extracting archive.
  • Options to start extraction automatically, to hide main Altap Self-Extractor dialog, to suppress summary message box and to automatically overwrite files in the target directory.
  • Easy and user friendly environment for creating self-extracting archives in Altap Salamander using ZIP plugin.
  • Creating self-extracting archives also from command line (using command line tool Zip2Sfx, you can find it in plugins\zip\zip2sfx subdirectory of Altap Salamander's installation directory).

The Altap Self-Extractor executable is packed in a compact sfx package (file) with the language dependent data (like texts in the main dialog, etc.). For each supported language there is a one standalone sfx package. Sfx packages are distributed with ZIP plugin.


Creating Self-Extracting Archive

There are tree ways how to create self-extracting archive:

From ZIP plugin menu

If you have already created a ZIP archive, you can convert it to self-extracting archive by command Create Self-Extracting Archive from menu Plugins/ZIP.

Specifying an option in Create New Archive dialog

When you pack files to a new archive (using Pack command from menu Files), ZIP plugin displays Create New Archive dialog. To create self-extracting archive check Create self-extracting archive in this dialog. If this dialog doesn't appear, check Display dialog with extended options before packing in your ZIP Configuration.

Creating self-extracting archive from command prompt

This feature is not available in ZIP plugin itself but is provided by a standalone application Zip2Sfx which is placed in plugins\zip\zip2sfx subdirectory of Altap Salamander's installation directory.

See Also

Altap Self-Extractor
Self-Extractor Settings
Create New Archive Dialog
ZIP Configuration
Self-Extractor Command Line Parameters


Self-Extractor Settings

Use the Advanced button in Create New Archive dialog to open Self-Extractor Settings dialog. In this dialog you can specify parameters of the self-extracting archive.

Contents

Menu Commands
Dialog Box Options
Self-Extractor Texts Dialog
Waiting for Another Application

See Also

Altap Self-Extractor
Creating Self-Extracting Archive


Menu Commands

The Self-Extractor Settings dialog contains menu with following commands:

In File Submenu:

Export Settings
Saves current self-extractor settings in the settings file in human readable and editable text form.
Import Settings
Loads self-extractor settings from the settings file. See sample.set for sample of self-extractor settings. It contains also details on syntax of self-extractor settings.

In View Submenu:

Preview
Displays preview of the self-extractor's main dialog box.

In Options Submenu:

Reset All
Restores both default values in the Self-Extractor Settings dialog and the default texts entered in the Self-Extractor Texts dialog.
Reset Values
Restores only default values in the Self-Extractor Settings dialog (it does not affect the texts entered in the Self-Extractor Texts dialog.
Reset Text
Restores only default texts entered in the Self-Extractor Texts dialog (according to the selected language; it does not affect values in the Self-Extractor Settings dialog).
Add to Favorites
Saves the current settings (including texts) to Favourites submenu (see its description below).
Favourites
Contains all saved settings (including texts). To load these settings, just click on appropriate menu item. To manage these settings, click on Manage item in this menu.
Last Used
Loads the last used self-extractor settings (including texts).


Dialog Box Options

The Self-Extractor Settings dialog contains following options:

Extract to

Specify the directory you want to be preset in Extract to editbox in the main dialog of self-extracting archive. You can enter either absolute or relative path. Relative path is relative to the current directory of the opened self-extracting archive. If Extract to specifies non-existing directory, user will be prompted whether to create it. To extract files to the current directory leave this field blank.

Samples of relative paths:
Gallery\Van Gogh
\Program Files\My Program
..\Pictures

At the beginning of the absolute path you can use one of the following variables:

Name | Description
$(Temp) | Temporary files directory. This variable should stand only alone (not followed by any path portion).
$(ProgFiles) | Program Files directory.
$(WinDir) | Windows directory.
$(SysDir) | System directory.
$[variable] Value of an environment variable.
Sample: $[windir]\Fonts
$<variable> Value of a Registry key value.
Sample: $<SOFTWARE\Microsoft\Windows\CurrentVersion\ProgramFilesDir>\Outlook Express
Allow user to change the directory
Allows user to change Extract to directory.
Execute command or open document

Here you can enter command (with optional parameters), document name, or HTTP link (must start with http://). It is executed (opened) when unpacking of the self-extracted archive finishes. In case of command or document name you can enter absolute path or relative path (relative to the current directory of the opened self-extracted archive).

Samples:
setup.exe -x
doc\readme.txt
https://www.altap.cz/

Remove extracted files
Removes files extracted to the temporary directory when application (e.g. installer) specified in Execute command or open document finishes. This option is enabled only when unpacking to temporary directory (Extract to is set to $(Temp)) and is useful for installation software.
Wait for
Self-extractor can also wait for other application than the one specified in Execute command or open document. See Waiting for Another Application for details.
Texts
Defines texts in the optional message box and main dialog of self-extracting archive. See Self-Extractor Texts dialog for details.
Language
Lets you choose the language version of the created self-extracting archive. If custom texts (texts specified in Self-Extractor Texts dialog) were not changed and you change language, texts are changed to the defaults of currently selected language. If custom texts were changed and you change language, following action depends on When SFX language changes in the ZIP Configuration. There are three variants: texts are changed to their default values, texts are left unchanged, or you are prompted whether to change their values to defaults or not.
Note: You can set values of custom texts to their defaults in Options menu or in the Self-Extractor Texts dialog.
Icon
Icon of self-extracting archive. This icon appears also in the main dialog. Only icon from ICO file or from Win32 executable could be loaded. Loading icons from 16-bit (e.g. Win 3.11 and older) executables is not supported.
Start extraction automatically
Starts extraction immediately after the self-extracting archive is opened. It does not display any user prompt.
Hide main self-extractor's dialog
Doesn't show main self-extractor's dialog and unpacks silently at the background. But error messages or overwrite prompts are displayed. The option make sense only if 'Start extraction automatically' is turned on.
Automatically create target directory
It creates target directory (if it's not existing) without any user prompt.
Show operation summary dialog
Shows message box informing whether the extraction was finished successfully and how much files were extracted in case of success.
Overwrite files automatically
Overwrites existing files in the Extract to directory without any user prompt. Attention: it overwrites also readonly/hidden/system files.
Requires administrative privileges
Starts self-extracting archive with administrative privileges on Windows Vista (this will trigger UAC - User Account Control), so it can unpack files also to write-protected folders (e.g. Program Files).

See Also

Self-Extractor Texts Dialog
Waiting for Another Application


Self-Extractor Texts Dialog

Use the Texts button in the Self-Extractor Settings dialog to open the Self-Extractor Texts dialog. In this dialog you can specify texts for the message box (optional) and the main dialog of self-extracting archive.

Message Box

Altap Self-Extractor can display message box before the unpacking is started. Unpacking continues only if user press button OK, Yes, or I Agree.

If you don't want to display this message box, leave both fields Title and Message empty.

Note: I Agree + I Disagree buttons can be used only with Long Message message box type.

Main Dialog Box

You can customize texts in self-extracting archive main dialog: title, text in dialog, the Extract button, vendor name, and the web link. Use the Preview SFX Dialog Box command from View menu in the Self-Extractor Settings dialog to see main dialog with your own texts.


Waiting for Another Application

Use the Wait For button in the Self-Extractor Settings dialog to open the Wait For dialog. This button is enabled only when unpacking to temporary directory (Extract to is set to $(Temp)) and Remove extracted files is checked.

Altap Self-Extractor can unpack files to temporary folder. Then it can start application specified in the Self-Extractor Settings dialog in the field Execute command or open document. When the started application finishes, self-extractor can remove temporary files and finish itself.

In some rare cases (some versions of Install Shield) the started application (let's call it App1) starts another application (App2) and finishes while the App2 is still running. In normal case the Altap Self-Extractor detects that the App1 has finished and because it does not know anything about the App2, it removes the temporary files and finishes itself. To prevent this problem you can specify the application for which the Altap Self-Extractor should wait. You can do it by specifying the filename of the App2 executable in the Wait for dialog.


Self-Extractor Command Line Parameters

User can start self-extracting archive with command line option -s. With this option self-extracting archive starts in safe mode. It means that following self-extractor options are forced: Allow user to change the directory is checked, Start extraction automatically is cleared and Hide main self-extractor's dialog is cleared. So it displays the main self-extractor dialog box and lets user to specify Extract to directory.

See Also

Self-Extractor Settings


Frequently Asked Questions

Can I customize the Altap Self-Extractor dialog box?
Yes, ZIP Plugin and Zip2Sfx provide you options for customizing the dialog box. You can set dialog box title, text in the dialog box and the text of the button which start the extraction. You can also add custom icon in the dialog box. See Self-Extractor Texts dialog for details.

Is it possible to change Extract to directory when running self-extracting archive even if the archive was created with an option disabling change of Extract to folder or with an option causing automatic start of extraction?
Yes. User can run self-extracting archive with command line option -s which cause start of self-extracting archive in safe mode. See Self-Extractor Command Line Parameters for details.

What is sfx package?
Sfx package is a file with extension .sfx. It contains Altap Self-Extractor executable and language dependent data like text in the main dialog. Data from sfx package are used when creating self-extracting archive.

Where are stored sfx packages?
Sfx packages are stored in plugins\zip\sfx subdirectory of the Altap Salamander's installation directory.